#!/usr/bin/env python

import os, sys, time, datetime, codecs, shutil, subprocess, re, math, base64

def compare_versions(version1, version2):
	def normalize(v):
		v = '.'.join(map((lambda s:re.sub(r'[^\d]+(.*)$','',s)), v.split('.')[:3]))
		return [int(x) for x in re.sub(r'(\.0+)*$','', v).split(".")]
	
	return cmp(normalize(version1), normalize(version2))

def test(code, exp):
	val = eval(code)
	if val == exp:
		print 'SUCCESS       %s == %s' % (code, exp)
	else:
		print 'FAILED        %s: expected %s, got %s' % (code, exp, val)

test('compare_versions("1.0", "2.0")', -1)
test('compare_versions("2.0", "1.0")', 1)
test('compare_versions("1.0", "1.0")', 0)
test('compare_versions("1.0", "1.0.1")', -1)
test('compare_versions("1.0.1", "1.0.2")', -1)
test('compare_versions("1.1.1", "1.0.2")', 1)
test('compare_versions("2.0.1", "2.0.1GA2")', 0)
test('compare_versions("2.0", "2.0.1GA2")', -1)
test('compare_versions("2.0.0", "2.0.1GA2")', -1)
test('compare_versions("2.0.1", "2.0.1GA2")', 0)
test('compare_versions("2.0.1GA2", "2.0")', 1)
test('compare_versions("2.0.1GA2", "2.2")', -1)
test('compare_versions("2.0.1", "2.0.1.v20120502173124")', 0)
test('compare_versions("2.0.1GA2", "2.0.1.v20120502173124")', 0)
test('compare_versions("2.0.0", "2.0.1.v20120502173124")', -1)
test('compare_versions("2", "2.0.1.v20120502173124")', -1)
test('compare_versions("2.0.2", "2.0.1.v20120502173124")', 1)
